# I am an the UI programmer. Fear me, or I will send buttons to haunt you! -- Joe


import os

import pygame
import ode
#import math
from pygame.locals import *
from data import *

import random
import asteroids
import trade

from globalvars import *
from pgu import engine
from pgu import timer
from pgu import gui

from locations import *

class Button(object):
	def __init__(self, image, pos, canClick):
		self.image = image
		self.imageOrig = image
		self.canClick = canClick
		#self.imageup = pygame.Surface([75,30])
		#self.imageup.fill([240,240,255])
		#self.imagedown = pygame.Surface([75,30])
		#self.imagedown.fill([100,100,215])
		
		#self.image = pygame.font.SysFont("arial", 20)
		#self.image = self.image.render(str(image), False, [0,0,0])
		
		imageDimensions = image.get_width(), image.get_height()
	
		self.image2 = pygame.transform.scale(image, (imageDimensions[0] -3, imageDimensions[1] -3))
		image2Dimensions = self.image2.get_width(), self.image2.get_height()
		#self.image2.set_alpha(50)
	
		#print image,self.image2
	
	
		self.imageup = pygame.Surface( imageDimensions ).convert_alpha()
		self.imagedown = pygame.Surface( image2Dimensions ).convert_alpha()
	
		self.imageup.blit(self.image, self.image.get_rect())
		self.imagedown.blit(self.image2, self.image.get_rect())
	
		self.rect = self.imageup.get_rect().move(pos)
	
		self.pressed = False
		self.release = False

        

	def update(self, screen,  mouse_pos, mouse_press):
		if self.canClick == True:
			self.release = False
        
			if mouse_press and self.rect.collidepoint(mouse_pos):
				self.pressed = True
			else:
				if self.pressed  and self.rect.collidepoint(mouse_pos):
					self.release = True
				self.pressed = False
	
			if self.pressed:
				self.image = self.image2
				#self.image = self.imagedown
				#self.imagedown.blit(self.image, self.image.get_rect())
			else:
				self.image = self.imageOrig
				#self.image = self.imageup
			#self.imageup.blit(self.image, self.image.get_rect())
	
		screen.blit(self.image, self.rect)
		#print screen

	
class Planet(object):
	def __init__(self, image, pos, canTravel, name, desc=""):
		self.canTravel = canTravel
		#self.image = image
		self.name = name
		self.desc = desc
		self.pos = pos
		
		self.imageOrig = image
		
		image2 = pygame.transform.scale(image, (image.get_width() -200, image.get_height() -200))
		
		self.button = Button(image2, pos, False)
		
		self.rect = image2.get_rect().move(pos[0]+25, pos[1]-5)
		
		self.image = pygame.transform.scale(image, (image.get_width() -145, image.get_height() -145))
		
		if self.canTravel == True:
			self.button = Button(image2, pos, True)
			
		self.redTriangle = loadImage("red_tri.png")
		self.greenTriangle = loadImage("green_tri.png")
		#self.triangle = loadImage("fuel1.png")

		
	def update(self, screen,  mouse_pos, mouse_press):
		
		#image = pygame.Surface((60, 5))
    		#image.fill((250, 250, 250))
		
		if self.canTravel == True:
			if self.name == "Asteroid Field":
				screen.blit(self.greenTriangle, (self.pos[0]+8, self.pos[1]-38))
			else:
				screen.blit(self.redTriangle, (self.pos[0]+8, self.pos[1]-38))
			#screen.blit(self.triangle, (self.rect[0]-25, self.rect[1]))
		
		self.button.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
		
	def getPlanetImage(self):
		return self.image

class NavUI(engine.State):	
	def __init__(self, game):
		self.game = game
		
	def init(self):
		self.game.playIntro = False # Just incase someone else didn't set this yet
		self.background = loadImage("space_backdrop1.png")
		self.navmap = loadImage("navigation-background.png")
		#self.sun = loadImage("sun.png")
		
		if self.game.sound:
			self.clickSound = loadSound("button-click.ogg")
			if self.game.musicPlaying != "nav":
				pygame.mixer.music.fadeout(900)
				loadMusic("song09.ogg")
				pygame.mixer.music.play(-1)
				self.game.musicPlaying = "nav"
		else:
			self.clickSound = None
			
		self.curPlanet = [' ', None]
		
		#self.game.cutsceneNumber = 1
		#print self.game.cutsceneNumber
		
		planet = loadImage("planet2.png")
		self.planet2 = loadImage("planet1.png")
		self.planet3 = loadImage("planet3.png")
		self.planet4 = loadImage("planet4.png")
		self.planet5 = loadImage("planet5.png")
		self.planet6 = loadImage("planet6.png")
		asteroidField = loadImage("asteroid_field.png")
		
		self.enableNextGalaxy = False
		
		
		self.buttonsPressed = {"asteroidGameButton": False}
		self.planetPressed = False
		self.buttons = []
		
		if self.enableNextGalaxy == True:
			self.nextGalaxy = Button(loadImage("go_button.png"), [700, 555], True)
			
		self.goButton = Button(loadImage("go_button.png"), [690, 20], True)
		self.backButton = Button(loadImage("back_button.png"), [10, 550], True)
		
		#so its more like locationName:ateriod/planet obj
		#[23:51] <Sam_Washburn> you can use isinstance(Obj,Classname) to tell what it is..
		#[23:51] <Sam_Washburn> or obj.__class__ too i guess.
		#print Galaxy.systems
		#print Galaxy.systems["KappaFive"]
		#print Galaxy.systems["KappaFive"].locations
		
		self.heavenlyBodies = Galaxy.systems["KappaFive"].locations

		#for body in self.heavenlyBodies:
		#	print Galaxy.systems["KappaFive"].locations[body].desc
			
		#print self.heavenlyBodies['LV426'].description
		
		self.heavenlyBodiesButtons = {}
		
		
		
		for bodyKey in self.heavenlyBodies:
			body = self.heavenlyBodies[bodyKey]
				
			
			print "Creating a planet button for " + body.name + " at " + str(body.pos) + " with image " + body.image
			
			#print body.image
			self.heavenlyBodiesButtons[bodyKey] = Planet(loadImage(body.image), body.pos, body.canTravel, body.name)
			
		
	def loop(self):		
		if self.goButton.release:
			if self.clickSound != None:
				self.clickSound.play(0)	

			for bodyKey in self.heavenlyBodies:
				body = self.heavenlyBodies[bodyKey]
				if body.name == self.curPlanet[0]:
					if body.asteroid == True:
						import asteroids
						return asteroids.Game(self.game, body)
				
					else:
					
						if globalvars.story.hasSceneOnEntry(self.curPlanet[0]):
							import cutscene
							return cutscene.CutsceneUI(self.game, globalvars.story.getSceneOnEntry(self.curPlanet[0]), self.curPlanet, self.heavenlyBodies)
						else:
							return trade.TradeUI(self.game, self.heavenlyBodies, self.curPlanet)
				
		if self.backButton.release:
			if self.clickSound != None:
				self.clickSound.play(0)
			import menu
			return menu.Menu(self.game)			
			
		for bodyKey in self.heavenlyBodiesButtons:
			body = self.heavenlyBodiesButtons[bodyKey]
			if body.button.pressed:
				self.planetPressed = True
				self.curPlanet[0] = self.heavenlyBodies[bodyKey].name
				self.curPlanet[1] = self.heavenlyBodies[bodyKey].image
				
	def update(self,screen):
		return self.paint(screen)
	
	def paint(self,screen):
		self.screen = screen
		
		screen.fill((0,0,0))
		screen.blit(self.background, (0,0))
		screen.blit(self.navmap, (0,50))
		#screen.blit(self.sun, (350,225))
			
		if self.planetPressed == True:
			self.goButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
			font = pygame.font.Font(os.path.join("data","Wanta.ttf"),20)
			planetName = font.render(self.curPlanet[0],1, (0,0,0))
			planetNameTitle = font.render("Name:",1, (0,0,0))
			
			#planetBackground = loadImage("description_box.png")
			planetDescBackground = loadImage("description-background.png")
		
			#screen.blit(planetBackground, (0,0))
			
			screen.blit(planetDescBackground, (120,0))
			for bodyKey in self.heavenlyBodies:
				body = self.heavenlyBodies[bodyKey]
				if body.name == self.curPlanet[0]:
					if body.name == "Whitefall":
						
						font = pygame.font.Font(os.path.join("data","Wanta.ttf"),18)
						planetName = font.render(self.curPlanet[0],1, (0,0,0))
						screen.blit(planetName, (182,8))
						
					else:
						screen.blit(planetName, (182,6))
					screen.blit(planetNameTitle, (127,6))
					
					bigPlanetImage = loadImage(body.image)
					imageDimensions = bigPlanetImage.get_width(), bigPlanetImage.get_height()
					planetImage = pygame.transform.scale(bigPlanetImage, (imageDimensions[0] -141, imageDimensions[1] -141))
					screen.blit(planetImage, (130,46))
					
					x, y = 276, 7
					for line in body.desc:
						text = font.render(line,1,(0,0,0))
						screen.blit(text, (x,y))
						y += 22
					
					x, y = 440, 7
					
					if body.asteroid == False:
						planetData = [
						("Atmosphere: "),
						("     "+str(body.atmosphere)),
						("Gravity: "+str(body.gravity)),
						("Year Length: "+str(body.yearLen))
						]
					
						for line in planetData:
							text = font.render(line,1,(0,0,0))
							screen.blit(text, (x,y))
							y += 22
			
			try:
				screen.blit(self.curPlanet[1], (133,48))
			except TypeError:
				image = pygame.Surface((1, 1))
    				image.fill((0, 0, 0))
				screen.blit(image, (-1,-1))
				
			descName = font.render("Description:",1, (0,0,0))
			
			x, y = 276, 7
		
		else:
			instructions = ["Click on a planet or asteroid field, then", "the 'Go!' button to navigate to it."]
			font = pygame.font.Font(os.path.join("data","lcd-dot-matrix.ttf"),25)
			colour = 255,255,255
			y = 10
			for line in instructions:
				img = font.render(line,1,colour)
				screen.blit(img, (10, y))
				y += 25
				
		
		if self.buttonsPressed["asteroidGameButton"] == True:
			self.goButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
			
		#self.asteroidGameButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
		self.backButton.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
		
		if self.enableNextGalaxy == True:
			self.nextGalaxy.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
		
		#for planet in self.planets:
			#planet.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
			#rectList.append(planet.rect)
			
		
		for bodyKey in self.heavenlyBodiesButtons:
			body = self.heavenlyBodiesButtons[bodyKey]
			body.update(screen, pygame.mouse.get_pos(),  pygame.mouse.get_pressed()[0])
		
		#pygame.display.update(rectList)
		pygame.display.flip()
		
	
	def event(self,e):
		
		if e.type == KEYDOWN:
			if e.key == K_ESCAPE:
				import menu
				return menu.Menu(self.game)
			
			if e.key == K_c:
				import cutscene
				return cutscene.CutsceneUI(self.game)
				
		
		elif e.type == KEYUP:
			if e.key == K_LEFT:
				pass
			elif e.key == K_RIGHT:
				pass
			
		elif e.type == MOUSEMOTION:
			pass		
		
		if e.type == MOUSEBUTTONDOWN:
			pass