from gameitems import *
from gamespaceobjs import *


class BluePlasmaAmmo(Ammo):
	mass 				= .3
	damage 				= 10
	lifetime 			= 1
	spriteFile 			= "ammo_blueplasma1.png"
class BluePlasmaBarrel(Barrel):
	refireDelay			= 0.1
	recoilForce			= 4
	muzzleVelocity		= 500
	firingAngleVariance	= 5
	ammoType			= BluePlasmaAmmo
class BluePlasmaCannon(Weapon):
	mass				= 2
	name 				= "Blue Plasma Cannon"
	description			= "This is your standard plasma cannon that shoots the blue variety. Buy one today!"
	cost				= 100
	barrelType 			= BluePlasmaBarrel
	aimerType 			= "Fixed"				# This is a string that can be 1 of 3 values

	
class GreenPlasmaAmmo(Ammo):
	mass 				= .3
	damage 				= 15
	lifetime 			= 1
	spriteFile 			= "ammo_plasmaball.png"
class GreenPlasmaBarrel(Barrel):
	refireDelay			= 0.2
	recoilForce			= 2
	muzzleVelocity		= 400
	firingAngleVariance	= 5
	ammoType			= GreenPlasmaAmmo
class GreenPlasmaCannon(Weapon):
	mass				= 2
	name 				= "Green Plasma Cannon"
	description			= "This is your standard plasma cannon that shoots the green variety. Buy one today!"
	cost				= 100
	barrelType 			= GreenPlasmaBarrel
	aimerType 			= "Fixed"				# This is a string that can be 1 of 3 values

	
class CannonBallI(Ammo):
	mass 				= .2
	damage	  			= 10
	lifetime 			= 1.5
	spriteFile 			= "ammo_cannonball1.png"
	spriteSize			= ( 8, 8 )
class CannonI(Barrel):
	refireDelay			= 0.4
	recoilForce			= 2
	muzzleVelocity		= 350
	firingAngleVariance	= 0	
	ammoType			= CannonBallI
class BaseCannonI(Weapon):
	mass				= 2
	name 				= "Cannon Level 1"
	description			= "It's weak, it's cheap, and for the right price -- which happens to be 100 galactic talents -- it's yours!"
	cost				= 100
	barrelType 			= CannonI
	aimerType 			= "Fixed"


class CannonBallII(Ammo):
	mass 				= .35
	damage	  			= 20
	lifetime 			= 1.75
	spriteFile 			= "ammo_cannonball1.png"
	spriteSize			= ( 12, 12 )
class CannonII(Barrel):
	refireDelay			= 0.4
	recoilForce			= 3
	muzzleVelocity		= 325
	firingAngleVariance	= 0
	ammoType			= CannonBallII
class BaseCannonII(Weapon):
	mass				= 2
	name 				= "Cannon Level 2"
	description			= "A good solid choice of a weapon."
	cost				= 500
	barrelType 			= CannonII
	aimerType 			= "Fixed"


class CannonBallIII(Ammo):
	mass 				= .5
	damage	  			= 40
	lifetime 			= 2
	spriteFile 			= "ammo_cannonball1.png"
	spriteSize			= ( 16, 16 )
class CannonIII(Barrel):
	refireDelay			= 0.4
	recoilForce			= 4
	muzzleVelocity		= 300
	firingAngleVariance	= 0
	ammoType			= CannonBallIII
class BaseCannonIII(Weapon):
	mass				= 2
	name 				= "Cannon Level 3"
	description			= "This gun's like Texas, only bigger. Big power, big damage, big pricetag. You know you want it! Just don't get drool on your circuits."
	cost				= 1500
	barrelType 			= CannonIII
	aimerType 			= "Fixed"


class Spitfire(Ammo):
	mass 				= .05
	damage	  			= 1
	lifetime 			= 1
	spriteFile 			= "ammo_spitfire.png"
class SpitfireBarrel(Barrel):
	refireDelay			= 0.05
	recoilForce			= .3
	muzzleVelocity		= 600
	firingAngleVariance	= 20
	ammoType			= Spitfire
class SpitfireCannon(Weapon):
	mass				= 1
	name 				= "Spitfire blaster"
	description			= "Fast and furious."
	cost				= 1500
	barrelType 			= SpitfireBarrel
	aimerType 			= "Fixed"


class Singularity(Ammo):
	mass 				= .01
	damage	  			= 100
	lifetime 			= 4
	spriteFile 			= "ammo_singularity.png"
class SingularityCreator(Barrel):
	refireDelay			= 0.5
	recoilForce			= 0
	muzzleVelocity		= 100
	firingAngleVariance	= 20
	ammoType			= Singularity
class SingularityProvider(Weapon):
	mass				= 1
	name 				= "Singularity event creator"
	description			= "Simply the most powerful explosive know to android.  Light fuse and get away."
	cost				= 2000
	barrelType 			= SingularityCreator
	aimerType 			= "Fixed"
